# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/org/jboss/aspects/%{name}/%{namedversion}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section free
%define reltag %{nil}
%define namedversion %{version}%{?reltag}

Name:           jboss-remoting-aspects
Version:        1.0.3
Release:        0.6%{?dist}
Epoch:          0
Summary:        JBoss Remoting Aspects
License:        LGPLv2+
Group:          Development/Java
URL:            http://www.jboss.org/
# svn -q export http://anonsvn.jboss.org/repos/jbossas/projects/jboss-aspects/tags/jboss-remoting-aspects-1.0.3/ tar cjf jboss-remoting-aspects-1.0.3.tar.bz2 jboss-remoting-aspects-1.0.3
Source0:        jboss-remoting-aspects-1.0.3.tar.bz2
Source1:        jboss-remoting-aspects-jpp-depmap.xml
Source2:        jboss-remoting-aspects-settings.xml
Source3:        jboss-remoting-aspects-component-info.xml 
Patch1:         jboss-remoting-aspects-Remoting_java.patch
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jboss-aop2
Requires:       jboss-common-core
Requires:       jboss-remoting
# XXX: 1.0.1
Requires:       jboss-security-aspects >= 0:1.0.0
Requires:       jboss-serialization
Requires:       jpackage-utils
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  jpackage-utils
BuildRequires:  maven2 >= 0:2.0.7
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-dependency
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-source
BuildRequires:	maven2-plugin-deploy
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-jboss-deploy-plugin
BuildRequires:  maven-shared-reporting-impl
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  jboss-aop2
BuildRequires:  jboss-serialization >= 0:1.0.3
BuildRequires:  junit4
# XXX: 1.0.1
BuildRequires:  jboss-security-aspects >= 0:1.0.0
BuildRequires:  jboss-transaction-aspects >= 0:1.0.0
BuildRequires:  jboss-common-core
BuildRequires:  jboss-common-logging-log4j >= 0:2.0.5
BuildRequires:  jboss-man >= 0:2.0.0
BuildRequires:  jboss-microcontainer2
BuildRequires:  jboss-naming
BuildRequires:  jboss-parent
BuildRequires:  jboss-remoting
BuildRequires:  concurrent >= 0:1.3.4
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JBoss remoting aspects.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q 
%patch1 -p0 -b .sav1

cp -p %{SOURCE2} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

%build
export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository
mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.test.skip=true \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -DaltDeploymentRepository=jboss-releases::default::file:`pwd`/maven2-brew \
        -Djboss.repository.root=file:`pwd`/maven2-brew \
        deploy javadoc:javadoc

%install
rm -rf %{buildroot}

# jars
install -d -m 755 %{buildroot}%{_javadir}
install -p -m 644 target/jboss-remoting-aspects.jar %{buildroot}%{_javadir}/%{name}-%{version}.jar
install -p -m 644 target/jboss-remoting-aspects-sources.jar %{buildroot}%{_javadir}/%{name}-sources-%{version}.jar
%{jar} -cf %{buildroot}%{_javadir}/%{name}-javadoc-%{version}.jar -C target/site/apidocs/ .
(cd %{buildroot}%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `/bin/echo ${jar} | sed "s|-%{version}||g"`; done)

# pom
install -d -m 755 %{buildroot}%{_datadir}/maven2/poms
install -p -m 644 pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap org.jboss.aspects jboss-remoting-aspects %{namedversion} JPP %{name}

# javadoc
install -d -m 755 %{buildroot}%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
mvn-jpp deploy:deploy-file -e -DpomFile=pom.xml -DrepositoryId=maven2-brew \
    -Durl=file:///%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew \
    -Dfile=$RPM_BUILD_ROOT%{_javadir}/%{name}-javadoc-%{version}.jar \
    -Dclassifier=javadoc

install -d -m 755 %{buildroot}%{repodir}
install -d -m 755 %{buildroot}%{repodirlib}
cp -p %{SOURCE3} %{buildroot}%{repodir}/component-info.xml
tag=`echo %{namedversion}-brew`
sed -i "s/@VERSION@/$tag/g" %{buildroot}%{repodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
install -d -m 755 %{buildroot}%{repodirsrc}
cp -p %{SOURCE0} %{buildroot}%{repodirsrc}
cp -p %{SOURCE1} %{buildroot}%{repodirsrc}
cp -p %{SOURCE2} %{buildroot}%{repodirsrc}
cp -p %{PATCH1} %{buildroot}%{repodirsrc}
cp -p %{buildroot}%{_javadir}/%{name}-%{version}.jar %{buildroot}%{repodirlib}/%{name}.jar
cp -p %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom %{buildroot}%{repodirlib}/%{name}.pom
cp -p %{buildroot}%{_javadir}/%{name}-sources-%{version}.jar %{buildroot}%{repodirlib}/%{name}-sources.jar
cp -p %{buildroot}%{_javadir}/%{name}-javadoc-%{version}.jar %{buildroot}%{repodirlib}/%{name}-javadoc.jar
%endif

%clean
rm -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}*/jboss-remoting-aspects-%{version}.jar
%{_javadir}*/jboss-remoting-aspects.jar
%{_javadir}*/jboss-remoting-aspects-javadoc-%{version}.jar
%{_javadir}*/jboss-remoting-aspects-javadoc.jar
%{_javadir}*/jboss-remoting-aspects-sources-%{version}.jar
%{_javadir}*/jboss-remoting-aspects-sources.jar
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}/%{name}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Wed Feb 16 2011 David Walluck <dwalluck@redhat.com> 0:1.0.4-0.6
- Requires: jboss-security-aspects >= 0:1.0.0
- fix repolib dir ownership
- don't call mvn install

* Tue Jan 18 2011 Martha Benitez <mbenitez@redhat.com> - 0:1.0.3-0.5
- Rebuild for MEAD
- Add BR qdox

* Mon Nov 22 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.0.3-0.4
- Build with maven 2.2.1
- Change BR maven-release to maven-release-plugin
- Add BR maven-deploy-plugin, maven-shared-reporting-impl

* Fri Aug 23 2010 Permaine Cheung <pcheung@redhat.com> 0:1.0.3-0.3
- Remove unapplied patch

* Fri Aug 20 2010 David Walluck <dwalluck@redhat.com> 0:1.0.3-0.2
- fix version in maven2 depmap entry and component-info.xml

* Fri Aug 20 2010 David Walluck <dwalluck@redhat.com> 0:1.0.3-0.1
- 1.0.3
- use external jboss-parent
- remove jboss-aspects-build-1.0.1.CR5.pom
- fix repolib option
- fix repolib
- update License

* Fri May 07 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.0.1-1.4.1
- rebuilt

* Fri Apr 12 2010 Yiqiao Wang <yiwang@redhatc.om> 0:1.0.0-1.4
- Rebuild 
- Fix depmap entry for dtdparser

* Tue Nov 17 2009 Martha Benitez <mbenitez@redhat.com> - 0:1.0.0-1.3
- Add repolib
- Add javadoc and sources to main package and repolib
- Add component-info.xml

* Mon Aug 31 2009 Yong Yang <yyang@redhat.com> - 0:1.0.0-1.2
- Replace jboss-aspects-build.pom with (B)R jboss-aspects-common

* Wed Aug 19 2009 Martha Benitez <mbenitez@redhat.com> - 0:1.0.1-1.1
- Comment BR jboss-security-aspects, jboss-transaction-aspects
- Change location of jboss-parent and jboss-aspects-build pom files
- Add BR asm
- Add patch to avoid use of jboss-security-aspects and jboss-transaction-aspects

* Thu Jun 25 2009 Ralph Apel <r.apel@r-apel.de> - 0:1.0.1-1.jpp5
- first release

